{$N+}
Program himaku; uses dos;
{Podgonka parametrov polos dl`a org. soed. i t.p.;
  isprawlena osh., swqz. s predp., chto koef. prohozhd. wsegda = 
  otnosheniju amplitud; real`no, esli nepogloshch. sredy s 
  razn. storon pl`onki raznye, treb. poprawochn. mnozh.,
  rawnyj [1/n]*sqrt(n-sin(theta)^2))/cos(theta) !
}

 {$i uses_gra.pas}
 {$i complsub.pas} {nado real -> double!}
 {$i shapkeps.inc}

 const csvy=2.995E+10 {skor.svyeta,sm/syek};
 type compvect=array[1..3] of complex;
 type arr22c=array[1..2,1..2] of complex;

  var e1:ekr;

 var sr:sryedy; dannprob1,dannprob2:DannDlyaEps;
  obrlammin,obrlammax,obrlam,k0:real;
  ipolyar:integer; theta,kx:real; kz:complex;
  Rotr,Rprokh0,popraw,Rprokh:double;
  k,E,B:compvect; tuda,obratno:complex;
  is,ik,il,i:integer;
  m,obrm:arr22c;
  a1,a2,a3,a4,a5,a6:complex;
  gd,gm,iobrlam:integer; thetagrad,d2:real;

 {$i himaku3b.inc}
 { $i CHCl3_2.inc}
procedure CHCl3_inc(var dann:DannDlyaEps);
{podogn.: Smit A.,Prikl.IK-sp-iya - n CHCl3, 550..1000 sm-1}
{dayot zavysh. n na VCh-krayu i zanizh. - na NCh; pochemu - nyeyasno}
{Sr.: Atlas sp-rov r-telej, pod red. V.A.Kopt`uga, Novos., 1975: d=100 mkm;
  kachestvenno soglas., khot`a dl`a opis. kryla nado umen`sh. gamma do ~8
  (pri etom ot real nado perejti k double) i zanovo utochnit` deps.
  Kachestvenno: pri d=100 mkm i ny~700 cm-1: deps=1.0E-4 -> 80%,
  1.0E-3 - 20%, 0.01 -> zashkal, 0.1 -> sil`n. zashkal. No ~3000 cm-1
  1.0E-4 -> ~0%.
  Pri deps=0.1 v tonk. slojakh zameten minimum (!) propusk. ili plecho
  na LO-chastote; fizich. smysl nejasen. ~700 cm-1 deps=0.1 ->
  nyl-nyt~20 cm-1 v sootv. s ozhid.
}
begin
 with dann do begin
  epsbesk:=2.0; sigma0:=0; tau:=1E-13 {uslovno - iz Te+Sb};
  npolos:=4;
  with arr[1] do begin obrlamt:=670; gamma:=10; deps:=0.005 end;
  with arr[2] do begin obrlamt:=760; gamma:=10; deps:=0.05 end;
  with arr[3] do begin obrlamt:=1215; gamma:=10; deps:=0.005 end;
  with arr[4] do begin obrlamt:=3020; gamma:=10; deps:=0.0001 end;
 end;
end;


 const d1_0:double=1.0;
 var nk:complex;

Begin writeln;
 {v 5-j vyers.tryeb.,chtoby syektsiya opyer-rov nye razryvalash po include}
 chcl3_inc(dannprob1);
 {with dannprob1 do for i:=1 to npolos do arr[i].gamma:=2.0;}
 with sr do begin nsryed:=3;
  with arr[1] do begin sozd(eps,1,0); epseff:=eps {byez zatukh.!}; d:=1 end;
  with arr[2] do begin {eps i epseff pyeryemyenn.} d:=20.0E-4; end;
  with arr[3] do begin sozd(eps,1,0); epseff:=eps; d:=1; end;
 end;
 theta:=45*(pi/180);
 {gd:=detect; initgraph(gd,gm,''); ramka;}

 initgraph_12;
 prisv_ekr(e1, 0,x_y,0,0.5, 0,4000,0,1,0,1,0,1);
 prisv_ramk(e1, 4,10,1,1); ramka(e1);

 obrlammin:=0; obrlammax:=4000;
 for ipolyar:=1 to 1 do begin {ipolyar=1 - By<>0, 2 - Ey<>0};
 for iobrlam:=1 to 4000 do begin
  obrlam:=obrlammin+(obrlammax-obrlammin)*(iobrlam/4000) {sm-1};
  k0:=2*pi*obrlam {=omega/c};
  NakhEps(dannprob1,obrlam,sr.arr[2]);
  csqrt(nk,sr.arr[2].eps);
  kx:=k0*sqrt(sr.arr[1].eps.re)*sin(theta);
  PoslPolya(E,B,sr.arr[sr.nsryed].epseff,k0,kx,ipolyar);
  DrugStorGran({E,B,}sr.arr[sr.nsryed].eps,sr.arr[sr.nsryed-1].eps);
  for is:=sr.nsryed-1 downto 2 do begin
   DrugStorSloya(E,B,sr,k0,kx,is,ipolyar);
   DrugStorGran({E,B,}sr.arr[sr.nsryed].eps,sr.arr[sr.nsryed-1].eps);
  end;
  sozdkz(kz,sr.arr[1].epseff,k0,kx);
  {SozdM(m,sr.arr[1].epseff,ipolyar); pri himaku3n.inc nye tryeb.}
  SozdObrM(m,obrm,sr.arr[1].epseff,ipolyar);
  if ipolyar=1 then mx(tuda,obratno,obrm,B[2],E[1]);
  if ipolyar=2 then mx(tuda,obratno,obrm,E[2],B[1]);
  Rotr:=sqr(d1_0*cabs(obratno)/cabs(tuda));
  Rprokh0:=sqr(1/cabs(tuda));
  popraw:=sr.arr[sr.nsryed].eps.re/sr.arr[1].eps.re;
  if ipolyar=1 then begin
   popraw:=(1/popraw)*sqrt(popraw-sqr(sin(theta)))*(1/cos(theta));
  end else begin
   popraw:=sqrt(popraw-sqr(sin(theta)))*(1/cos(theta));
  end;
  Rprokh:=Rprokh0*popraw;
  {writeln('obrlam,tuda,obr,sum,R,T=',
    obrlam:7:2,cabs(tuda):7:2,cabs(obratno):7:2,
    cabs(tuda)+cabs(obratno):7:2,
    Rotr:7:2,Rprokh:7:2);}
  {writeln('obrlam,Rotr=',obrlam:10:4,Rotr:10:4);}
  po(obrlam,Rotr,e1,13);
  po(obrlam,Rprokh,e1,15);
  po(obrlam,nk.re/10,e1,12);
  po(obrlam,Rotr+Rprokh,e1,14);
 end {iobrlam};
 end{ipolyar};
 readln; closegraph;
End.
