{dlya odnovr-sti izmyen. - obshch.shapka}
 const nsryedmax=10;
 type sryeda=record eps,epseff:complex; d:real end;
 type sryedy=record nsryed:integer; arr:array[1..nsryedmax] of sryeda end;
 const npolosmax=10;
 type polosa=record obrlamt,gamma,deps:real; end;
 type DannDlyaEps=record
  epsbesk,sigma0,tau:real;
  npolos:integer;
  arr:array[1..npolosmax] of polosa;
 end;

 procedure NakhEps(dann1:DannDlyaEps; obrlam:real; var sr1:sryeda);
  const csvy=2.998E10;
  var a1,a2,a3,a4,a5,a6,sigma:complex; ny,omega:real; i:integer;
 begin
  with dann1 do begin
    sozd(sr1.eps,epsbesk,0);
    for i:=1 to npolos do with arr[i] do begin
     sozd(a1,sqr(obrlamt)-sqr(obrlam),-gamma*obrlam);
     sozd(a2,sqr(obrlamt)*deps,0);
     c(a3,a2,a1); s(a4,sr1.eps,a3); sr1.eps:=a4
    end;
    ny:=csvy*obrlam; omega:=2*pi*ny;
    sozd(a1,1,-omega*tau); sozd(a2,sigma0,0); c(sigma,a2,a1);
    {sigma=sigma0/(1-i*omega*tau) - f-la Drude}
    sozd(a1,0,4*pi/omega); p(a2,a1,sigma);
    s(sr1.epseff,sr1.eps,a2);
  end {with dann1};
 end;

